import io.api.sample.TableNotification;
import io.confluent.kafka.serializers.protobuf.KafkaProtobufDeserializer;
import io.confluent.kafka.serializers.protobuf.KafkaProtobufSerializer;
import io.confluent.kafka.serializers.protobuf.KafkaProtobufSerializerConfig;
import org.junit.Test;

import java.util.Properties;

import static org.junit.Assert.*;

public class ConfluentTest {

    @Test
    //This demonstrates two issues with ccompact api
    //1) PROTOBUF schema type not being returned
    //2) For protobuf complex definitions the linked schemas are not returned.
    public void testSample() {

        Properties properties = new Properties();
        properties.setProperty(KafkaProtobufSerializerConfig.SCHEMA_REGISTRY_URL_CONFIG, "http://localhost:8080/apis/ccompat/v6");
        properties.setProperty(KafkaProtobufSerializerConfig.AUTO_REGISTER_SCHEMAS, "true");

        KafkaProtobufSerializer kafkaProtobufSerializer = new KafkaProtobufSerializer();
        kafkaProtobufSerializer.configure(properties, false);


        byte[] data = kafkaProtobufSerializer.serialize("test",  TableNotification.newBuilder().build());


        KafkaProtobufDeserializer protobufKafkaDeserializer = new KafkaProtobufDeserializer();
        protobufKafkaDeserializer.configure(properties, false);

        protobufKafkaDeserializer.deserialize("test", data);
    }

}